// Author: Bob Rubbens - Knights of the Compiler
// Creation date: ma 10-08-2014
// Contact: http://plusminos.nl - @broervanlisa - gmail (bobrubbens)

// Public
#include <memory>
#include <SDL2/SDL.h>
#include <SDL2/SDL_image.h>
#include <SDL2/SDL_ttf.h>
#include <vector>

// Private
#include "game/Cloud.hpp"
#include "game/TypeTracker.hpp"

class CloudManager {
public:
	CloudManager();
	~CloudManager();

	void launchCloud();
	float getWaterLvl() const;
	int getTypedWords() const;
	
	void event(SDL_Event &e);
	void logic(TypeTracker &ttracker, float dt);
	void render(SDL_Renderer *tgt) const;

private:
	std::vector<std::unique_ptr<Cloud>> clouds;
	int clearedClouds = 0;
	float waterLvl = 0.0;
	SDL_Texture* cloudTexture;
	SDL_Texture* rainTexture;
	bool frozen = false;
} ;
